## dump1090-4.0.tar.gz

=== Makefile ===
PROGNAME=dump1090

DUMP1090_VERSION ?= unknown

CPPFLAGS += -DMODES_DUMP1090_VERSION=\"$(DUMP1090_VERSION)\" -DMODES_DUMP1090_VARIANT=\"dump1090-fa\"

DIALECT = -std=c11
CFLAGS += $(DIALECT) -O3 -g -Wall -Wmissing-declarations -Werror -W -D_DEFAULT_SOURCE -fno-common
LIBS = -lpthread -lm
SDR_OBJ = sdr.o fifo.o sdr_ifile.o

# Try to autodetect available libraries via pkg-config if no explicit setting was used
PKGCONFIG=$(shell pkg-config --version >/dev/null 2>&1 && echo "yes" || echo "no")
ifeq ($(PKGCONFIG), yes)
  ifndef RTLSDR
    ifdef RTLSDR_PREFIX
      RTLSDR := yes
    else
      RTLSDR := $(shell pkg-config --exists librtlsdr && echo "yes" || echo "no")
    endif
  endif

  ifndef BLADERF
    BLADERF := $(shell pkg-config --exists libbladeRF && echo "yes" || echo "no")
  endif

  ifndef HACKRF
    HACKRF := $(shell pkg-config --exists libhackrf && echo "yes" || echo "no")
  endif

  ifndef LIMESDR
    LIMESDR := $(shell pkg-config --exists LimeSuite && echo "yes" || echo "no")
  endif
else
  # pkg-config not available. Only use explicitly enabled libraries.
  RTLSDR ?= no
  BLADERF ?= no
  HACKRF ?= no
  LIMESDR ?= no
endif

UNAME := $(shell uname)

ifeq ($(UNAME), Linux)
  CFLAGS += -D_DEFAULT_SOURCE
  LIBS += -lrt
  LIBS_USB += -lusb-1.0
endif

ifeq ($(UNAME), Darwin)
  ifneq ($(shell sw_vers -productVersion | egrep '^10\.([0-9]|1[01])\.'),) # Mac OS X ver <= 10.11
    CFLAGS += -DMISSING_GETTIME
    COMPAT += compat/clock_gettime/clock_gettime.o
  endif
  CFLAGS += -DMISSING_NANOSLEEP
  COMPAT += compat/clock_nanosleep/clock_nanosleep.o
  LIBS_USB += -lusb-1.0
endif

ifeq ($(UNAME), OpenBSD)
  CFLAGS += -DMISSING_NANOSLEEP
  COMPAT += compat/clock_nanosleep/clock_nanosleep.o
  LIBS_USB += -lusb-1.0
endif

ifeq ($(UNAME), FreeBSD)
  CFLAGS += -D_DEFAULT_SOURCE
  LIBS += -lrt
  LIBS_USB += -lusb
endif

RTLSDR ?= yes
BLADERF ?= yes

ifeq ($(RTLSDR), yes)
  SDR_OBJ += sdr_rtlsdr.o
  CPPFLAGS += -DENABLE_RTLSDR

  ifdef RTLSDR_PREFIX
    CPPFLAGS += -I$(RTLSDR_PREFIX)/include
    ifeq ($(STATIC), yes)
      LIBS_SDR += -L$(RTLSDR_PREFIX)/lib -Wl,-Bstatic -lrtlsdr -Wl,-Bdynamic $(LIBS_USB)
    else
      LIBS_SDR += -L$(RTLSDR_PREFIX)/lib -lrtlsdr $(LIBS_USB)
    endif
  else
    # some packaged .pc files are massively broken, try to handle it

    # FreeBSD's librtlsdr.pc includes -std=gnu89 in cflags
    RTLSDR_CFLAGS := $(shell pkg-config --cflags librtlsdr)
    CFLAGS += $(filter-out -std=%,$(RTLSDR_CFLAGS))

    # some linux librtlsdr packages return a bare -L with no path in --libs
    # which horribly confuses things because it eats the next option on the command line
    RTLSDR_LFLAGS := $(shell pkg-config --libs-only-L librtlsdr)
    ifeq ($(RTLSDR_LFLAGS),-L)
      LIBS_SDR += $(shell pkg-config --libs-only-l --libs-only-other librtlsdr)
    else
      LIBS_SDR += $(shell pkg-config --libs librtlsdr)
    endif
  endif
endif

ifeq ($(BLADERF), yes)
  SDR_OBJ += sdr_bladerf.o
  CPPFLAGS += -DENABLE_BLADERF
  CFLAGS += $(shell pkg-config --cflags libbladeRF)
  LIBS_SDR += $(shell pkg-config --libs libbladeRF)
endif

ifeq ($(HACKRF), yes)
  SDR_OBJ += sdr_hackrf.o
  CPPFLAGS += -DENABLE_HACKRF
  CFLAGS += $(shell pkg-config --cflags libhackrf)
  LIBS_SDR += $(shell pkg-config --libs libhackrf)
endif

ifeq ($(LIMESDR), yes)
  SDR_OBJ += sdr_limesdr.o
  CPPFLAGS += -DENABLE_LIMESDR
  CFLAGS += $(shell pkg-config --cflags LimeSuite)
  LIBS_SDR += $(shell pkg-config --libs LimeSuite)
endif

all: showconfig dump1090 view1090

showconfig:
	@echo "Building with:" >&2
	@echo "  Version string:  $(DUMP1090_VERSION)" >&2
	@echo "  RTLSDR support:  $(RTLSDR)" >&2
	@echo "  BladeRF support: $(BLADERF)" >&2
	@echo "  HackRF support:  $(HACKRF)" >&2
	@echo "  LimeSDR support: $(LIMESDR)" >&2

all: dump1090 view1090

%.o: %.c *.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

dump1090: dump1090.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o demod_2400.o stats.o cpr.o icao_filter.o track.o util.o convert.o ais_charset.o $(SDR_OBJ) $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) $(LIBS_SDR) -lncurses

view1090: view1090.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o ais_charset.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) -lncurses

faup1090: faup1090.o anet.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o ais_charset.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS)

clean:
	rm -f *.o oneoff/*.o compat/clock_gettime/*.o compat/clock_nanosleep/*.o dump1090 view1090 faup1090 cprtests crctests convert_benchmark

test: cprtests
	./cprtests

cprtests: cpr.o cprtests.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm

crctests: crc.c crc.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -DCRCDEBUG -o $@ $<

benchmarks: oneoff/convert_benchmark
	oneoff/convert_benchmark

oneoff/convert_benchmark: oneoff/convert_benchmark.o convert.o util.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm -lpthread

oneoff/decode_comm_b: oneoff/decode_comm_b.o comm_b.o ais_charset.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm

=== debian/changelog ===
dump1090-fa (4.0) stable; urgency=medium

  * dump1090: Build support for OS X, FreeBSD, OpenBSD [courtesy @mikenor / @apparentorder on Github, PRs #33 / #38]
  * dump1090: Overhaul of SDR / ring buffer / demodulator interface to make it easier to add new SDR types
  * dump1090: LimeSDR support [courtesy @Glutton on Github, PR #75]
  * dump1090: HackRF support [courtesy @kr105 on Github, PR #57]
  * dump1090: Stratux-compatible network output [courtesy @Determinant on Github, PR #61]
  * dump1090: Change option syntax for 2-bit correction from --fix --fix (introduced in 3.8.0) to --fix-2bit. Any number of --fix options now yields 1-bit correction.
  * dump1090: Support building under GCC 10 (github issue #65)
  * dump1090: Include a (disabled by default) example HTTPS configuration [courtesy @jwbernin on Github, PR #66)
  * dump1090: For manual builds, if no explicit SDR choice is made, autodetect available libraries via pkg-config
  * dump1090: Add a --version command-line option that shows just the version without needing to show the full help screen
  * dump1090: Only emit verbose command-line option help if --help is requested, not on any error
  * dump1090: List supported device types if --device-type is given without a device type
  * dump1090: Removed Debian Wheezy support (distribution is no longer supported upstream)
  * dump1090: Remove the "dump1090" Debian metapackage that exists only to provide an upgrade path from very very old installs
  * dump1090: Add package profiles to selectively build packages with reduced SDR library dependencies. See the README for details.
  * dump1090: If a network port option (--net-bo-port et al) is given on the command line, implicitly enable networking, but don't enable the default port assignments
  * dump1090: Provide Mode A / Mode C hit count in aircraft.json
  * SkyAware: Update aircraft registry to 20200924
  * SkyAware: Update to OpenLayers6
  * SkyAware: New basemap layers added/enabled
  * SkyAware: Added customizable aircraft table columns
  * SkyAware: Added URL query parameter feature to customize display [courtesy @sigwx on Github, PR #58)
  * SkyAware: Display registration number in aircraft table if ident is not present
  * SkyAware: Fix duplicated Access-Control-Allow-Origin header [courtesy @ianrenton on Github, PR #74)

 -- Eric Tran <eric.tran@flightaware.com>  Thu, 24 Sep 2020 10:21:00 -6000

dump1090-fa (3.8.1) stable; urgency=medium

  * SkyAware: Fixed SkyAware banner aspect ratio
  * SkyAware: Fixed issue with "Group By Data Type" and "All Aircraft Trails" checkboxes
    not saving across browser refreshes
  * SkyAware: Fixed bug with ShowFlags=False config.js setting
  * SkyAware: Added position age to aircraft detail pane
  * SkyAware: Added ability to customize range ring distances in SkyAware

 -- Eric Tran <eric.tran@flightaware.com>  Thu, 19 Mar 2020 09:20:00 -6000

dump1090-fa (3.8.0) stable; urgency=medium

  * general: Added support for building on Buster.
  * general: Replace use of usleep with nanosleep (PR #53)

  * dump1090: When applying CRC correction to a DF11 message, assume that the interrogator
    overlay value was 0 (e.g. as in an acquisiton squitter) and use the full 24-bit syndrome
    to correct errors; do not zero out the low 7 bits of the syndrome.
  * dump1090: Changes in aircraft tracking to try to reduce the number of bogus aircraft seen
    due to noise; this replaces the crude "require 2 messages" metric used previously.
  * dump1090: Added a new statistic for "unreliable tracks", aircraft that were tracked but
    which never passed the threshold for being considered a real aircraft.
  * dump1090: Added support for per-connection verbatim mode. "--net-verbatim" now controls the
    default connection setting, and the per-connection mode can be changed by a Beast settings
    command.
  * dump1090: Replaced "--aggressive" with "--fix --fix" for 2-bit CRC correction; include
    support for this in the standard build. 2-bit corrected messages are only emitted on
    verbatim connections.
  * dump1090: Update package default options: include "--fix", increase "--net-ro-size",
    decrease "--net-ro-interval", remove a duplicated "--net-bo-port" option.
  * dump1090: Fixes to CPR decoding when multiple position sources (e.g. ADS-B and MLAT) are
    being simultaneously received (PR #55)
  * dump1090: Track ADS-B, ADS-R, and TIS-B versions independently; use the appropriate version
    when decoding version-dependent messages.

  * view1090: Include ADS-B version in interactive display
  * view1090: Display a warning in the header in interactive mode if the dump1090 connection
    has been lost
  * view1090: Request verbatim mode when connecting to dump1090
  * view1090: Exit on connection loss in --no-interactive mode

  * SkyAware: Corrected icon selection for some aircraft types
  * SkyAware: Fixed display of settings checkboxes on high-DPI displays (PR #54)
  * SkyAware: Fixes to info box display (PR #51)
  * SkyAware: Hide scroll bar when not needed (PR #22)
  * SkyAware: Update aircraft registry to 20191216

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Mon, 30 Dec 2019 22:11:52 +0800

dump1090-fa (3.7.2) stable; urgency=medium

  * dump1090: Fix reversed sense of Track Angle/Heading bit in surface opstatus messages
  * dump1090: Have filter-regs emit a special value "-COMPUTED-" for filtered data
    values, rather than blanking them out entirely
  * Fix registration side mappings with a non-zero offset
  * dump1090: Update aircraft DB to 20190816
  * dump1090: Reject outright libbladerf that's too old
  * dump1090: Trigger build after bladeRF build; turn off build durability; turn
    off concurrent builds
  * SkyAware: SkyAware Renaming
  * SkyAware: Fix some display errors for ground vehicles
  * SkyAware: Fix aircraft trail handling

 -- Eric Tran <eric.tran@flightaware.com>  Mon, 09 Sep 2019 09:25:00 -6000

dump1090-fa (3.7.1) stable; urgency=medium



=== debian/control ===
Source: dump1090-fa
Section: embedded
Priority: extra
Maintainer: Oliver Jowett <oliver.jowett@flightaware.com>
Build-Depends: debhelper(>=9),
  librtlsdr-dev <!custom> <rtlsdr>,
  libbladerf-dev <!custom> <bladerf>,
  libhackrf-dev <!custom> <hackrf>,
  liblimesuite-dev <!custom> <limesdr>,
  libusb-1.0-0-dev <!custom> <rtlsdr> <bladerf> <hackrf> <limesdr>,
  pkg-config, dh-systemd, libncurses5-dev
Standards-Version: 3.9.3
Homepage: http://www.flightaware.com/
Vcs-Git: https://github.com/flightaware/dump1090.git

Package: dump1090-fa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lighttpd
Description: FlightAware ADS-B Ground Station System for SDRs
 Networked Aviation Mode S / ADS-B decoder/translator with support
 for RTL-SDR, BladeRF, HackRF, and LimeSDR software defined radio USB
 device support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

ifeq ($(DEB_HOST_ARCH),armhf)
  # Assume a Pi-like target, where using an 8-bit table is a fairly big win over the float path
  CPPFLAGS += -DSC16Q11_TABLE_BITS=8
endif

ifeq (,$(filter custom,$(DEB_BUILD_PROFILES)))
  # Standard build
  RTLSDR = yes
  BLADERF = yes
  HACKRF = yes
  LIMESDR = yes
else
  # Custom build
  ifneq (,$(filter rtlsdr,$(DEB_BUILD_PROFILES)))
    RTLSDR = yes
  else
    RTLSDR = no
  endif
  ifneq (,$(filter bladerf,$(DEB_BUILD_PROFILES)))
    BLADERF = yes
  else
    BLADERF = no
  endif
  ifneq (,$(filter hackrf,$(DEB_BUILD_PROFILES)))
    HACKRF = yes
  else
    HACKRF = no
  endif
  ifneq (,$(filter limesdr,$(DEB_BUILD_PROFILES)))
    LIMESDR = yes
  else
    LIMESDR = no
  endif
endif

override_dh_auto_build:
	dh_auto_build -- RTLSDR=$(RTLSDR) BLADERF=$(BLADERF) HACKRF=$(HACKRF) LIMESDR=$(LIMESDR) DUMP1090_VERSION=$(DEB_VERSION)

override_dh_install:
	dh_install
	install -d debian/dump1090-fa/usr/bin
	cp -a dump1090 debian/dump1090-fa/usr/bin/dump1090-fa
	cp -a view1090 debian/dump1090-fa/usr/bin/view1090-fa

%:
	dh $@ --with=systemd
